Summary: Web application monitoring the computing element
Name: glite-ce-monitor
Version: 1.16.1
Release: 2%{?dist}%{!?dist:.el5}
License: Apache Software License
Vendor: EMI
URL: http://glite.cern.ch/
Group: System Environment/Libraries
BuildArch: noarch
BuildRequires: maven
Requires: glite-ce-monitor-api-java, canl-java-axis2
Provides: glite-ce-ce-plugin
Obsoletes: glite-ce-ce-plugin
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
AutoReqProv: yes
Source: %{name}.tar.gz

%global _tomcat tomcat6
%global _webapplibdir /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/lib

%description
The CE monitor service is a web application that 
publishes information about the Computing Element

%prep 

%setup -c -q 

%build
mvn -Drpm.repackaging=false -DskipTests compile

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}
mvn -Drpm.repackaging=false -DskipTests install
mkdir -p %{buildroot}/usr/share/java
cp %{_builddir}/%{name}-%{version}/target/cemonitor-1.16.1.jar %{buildroot}/usr/share/java/glite-ce-monitor.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/ClassAdProcessor.jar %{buildroot}/usr/share/java/glite-ce-monitor-ClassAdProcessor.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/DoNotSendNotificationAction.jar %{buildroot}/usr/share/java/glite-ce-monitor-DoNotSendNotificationAction.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/RegExProcessor.jar %{buildroot}/usr/share/java/glite-ce-monitor-RegExProcessor.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/SendExpiredNotificationAction.jar %{buildroot}/usr/share/java/glite-ce-monitor-SendExpiredNotificationAction.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/SendNotificationAction.jar %{buildroot}/usr/share/java/glite-ce-monitor-SendNotificationAction.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/CESensor.jar %{buildroot}/usr/share/java/glite-ce-ce-plugin.jar
mkdir -p %{buildroot}/usr/share/glite-ce-monitor/services
cp %{_builddir}/%{name}-%{version}/target/axis2/cemonitor-service.jar %{buildroot}/usr/share/glite-ce-monitor/services/glite-ce-monitor.aar
mkdir -p %{buildroot}/usr/share/glite-ce-monitor/modules
cp %{_builddir}/%{name}-%{version}/target/axis2/cemonitor-authorization.jar %{buildroot}/usr/share/glite-ce-monitor/modules/glite-ce-monitor-authorization.mar
mkdir -p %{buildroot}/etc/glite-ce-monitor
cp %{_builddir}/%{name}-%{version}/config/*.template %{buildroot}/etc/glite-ce-monitor
cp %{_builddir}/%{name}-%{version}/config/*.properties %{buildroot}/etc/glite-ce-monitor
cp %{_builddir}/%{name}-%{version}/config/web.xml %{buildroot}/etc/glite-ce-monitor
sed -e 's|__CHANGE_SERVICE__|/etc/glite-ce-monitor/cemonitor-config.xml|g' \
    -e 's|__CHANGE_LOG4J__|/etc/glite-ce-monitor/log4j.properties|g' \
    %{_builddir}/%{name}-%{version}/config/axis2.xml > %{buildroot}/etc/glite-ce-monitor/axis2.xml

%clean
rm -rf %{buildroot}

%pre
for((idx=0; idx<5; idx++)) ; do
  /sbin/service %{_tomcat} stop
  if [ $? == 0 ] ; then idx=5; else sleep 5; fi
done

%post
set -e 

[ -d /var/lib/%{_tomcat}/webapps/ce-monitor ] || cp -R /usr/share/axis2/webapp /var/lib/%{_tomcat}/webapps/ce-monitor
  
if [ -e /usr/share/java/bcprov-1.46.jar ] ; then
    ln -sf /usr/share/java/bcprov-1.46.jar %{_webapplibdir}/bcprov.jar
else
    ln -sf /usr/share/java/bcprov.jar %{_webapplibdir}
fi

if [ -e /usr/share/java/bcmail-1.46.jar ] ; then
    ln -sf /usr/share/java/bcmail-1.46.jar %{_webapplibdir}/bcmail.jar
else
    ln -sf /usr/share/java/bcmail.jar %{_webapplibdir}
fi

[ -h %{_webapplibdir}/cedar.jar ] || ln -s /usr/share/java/jclassads/cedar.jar %{_webapplibdir}
[ -h %{_webapplibdir}/classad.jar ] || ln -s /usr/share/java/jclassads/classad.jar %{_webapplibdir}
[ -h %{_webapplibdir}/argus-pep-api-java.jar ] || ln -s /usr/share/java/argus-pep-api-java.jar %{_webapplibdir}
[ -h %{_webapplibdir}/argus-pep-common.jar ] || ln -s /usr/share/java/argus-pep-common.jar %{_webapplibdir}
[ -h %{_webapplibdir}/canl.jar ] || ln -s /usr/share/java/canl.jar %{_webapplibdir}
[ -h %{_webapplibdir}/canl-java-axis2.jar ] || ln -s /usr/share/java/canl-java-axis2.jar %{_webapplibdir}
[ -h %{_webapplibdir}/glite-ce-common-java.jar ] || ln -s /usr/share/java/glite-ce-common-java.jar %{_webapplibdir}
[ -h %{_webapplibdir}/glite-ce-monitor-api-java.jar ] || ln -s /usr/share/java/glite-ce-monitor-api-java.jar %{_webapplibdir}
[ -h %{_webapplibdir}/glite-ce-monitor.jar ] || ln -s /usr/share/java/glite-ce-monitor.jar %{_webapplibdir}
[ -h %{_webapplibdir}/voms-api-java3.jar ] || ln -s /usr/share/java/voms-api-java3.jar %{_webapplibdir}

#removing EMI-2 symlinks
[ -h %{_webapplibdir}/trustmanager-axis2.jar ] && rm -f %{_webapplibdir}/trustmanager-axis2.jar 
[ -h %{_webapplibdir}/trustmanager.jar ] && rm -f %{_webapplibdir}/trustmanager.jar
[ -h %{_webapplibdir}/voms-api-java.jar ] && rm -f %{_webapplibdir}/voms-api-java.jar

#removing EMI-3 compat symlinks
[ -h %{_webapplibdir}/argus-pep-api-java-compat.jar ] && rm -f %{_webapplibdir}/argus-pep-api-java-compat.jar
[ -h %{_webapplibdir}/argus-pep-common-compat.jar ] && rm -f %{_webapplibdir}/argus-pep-common-compat.jar

#removing broken links from previous installation
find -L %{_webapplibdir} -type l -exec rm -f '{}' \;

%if 0%{?el6}
# set allowLinking option for tomcat6
if [ ! -d /var/lib/%{_tomcat}/webapps/ce-monitor/META-INF ] ; then
  mkdir /var/lib/%{_tomcat}/webapps/ce-monitor/META-INF
  echo '<Context override="true" allowLinking="true"></Context>' > /var/lib/%{_tomcat}/webapps/ce-monitor/META-INF/context.xml
fi
%endif

ln -sf /usr/share/glite-ce-monitor/modules/glite-ce-monitor-authorization.mar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules
find /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules -name *.mar -exec basename \{\} \; > /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/modules/modules.list
  
ln -sf /usr/share/glite-ce-monitor/services/glite-ce-monitor.aar /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services
find /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services -name *.aar -exec basename \{\} \; > /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/services/services.list

# cannot use symlinks for the following files:
cp -f /etc/glite-ce-monitor/web.xml /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/
cp -f /etc/glite-ce-monitor/axis2.xml /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/conf/axis2.xml
chmod 600 /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/conf/axis2.xml
chown tomcat.tomcat /var/lib/%{_tomcat}/webapps/ce-monitor/WEB-INF/conf/axis2.xml

if [ $1 -eq 1 ] ; then  
# Creation of the back-end and log dir
  if [ ! "x`grep tomcat /etc/passwd`" == "x" ] ; then
    mkdir -p /var/cemonitor
    chown tomcat:tomcat /var/cemonitor
    chmod 755 /var/cemonitor
    
    mkdir -p /var/log/cemonitor
    chown tomcat:tomcat /var/log/cemonitor
    chmod 755 /var/log/cemonitor
  fi

  /sbin/service %{_tomcat} start

fi

%preun
if [ $1 -eq 0 ] ; then

  for((idx=0; idx<5; idx++)) ; do
    /sbin/service %{_tomcat} stop
    if [ $? == 0 ] ; then idx=5; else sleep 5; fi
  done

  if [ -d /var/cemonitor ] ; then
    rm -rf /var/cemonitor
  fi
  
  if [ -d /var/lib/%{_tomcat}/webapps/ce-monitor ] ; then
    rm -rf /var/lib/%{_tomcat}/webapps/ce-monitor
  fi

  if [ -e /etc/%{_tomcat}/Catalina/localhost/ce-monitor.xml ] ; then
    rm -f /etc/%{_tomcat}/Catalina/localhost/ce-monitor.xml
  fi

fi

%postun
/sbin/service %{_tomcat} start

%files
%defattr(-,root,root)
%dir /etc/glite-ce-monitor/
%config(noreplace) /etc/glite-ce-monitor/cemonitor-config-argus.xml.template
%config(noreplace) /etc/glite-ce-monitor/cemonitor-config-gjaf.xml.template
%config(noreplace) /etc/glite-ce-monitor/log4j.properties
%config(noreplace) /etc/glite-ce-monitor/*.xml
/usr/share/java/*.jar
/usr/share/glite-ce-monitor/modules/*
/usr/share/glite-ce-monitor/services/*

%changelog
* Fri Jun 28 2013 CREAM group <cream-support@lists.infn.it> - 1.16.1-2
- New major release


